Configuration management

This section contains configuration management proto files.

config_service.proto

ConfigurationManager

This service allows managing configsets and templates.

gRPC method definitions

gRPC method definitions
Method Name Request Type Response Type Description
CreateConfigset CreateConfigset
Request
CreateConfigset
Response
Creates a new configset or a new revision of an existing configset. If the validation flag is set to true, the configset is validated. The newly created configset’s state is SAVED or VALIDATED (not ACTIVE).
ValidateConfigsetRevision ValidateConfigsetRevision
Request
ValidateConfigsetRevision
Response
Validates the values of the configset’s parameters. If validated successfully, the configset’s state is set to VALIDATED.
ActivateConfigsetRevision ActivateConfigsetRevision
Request
ActivateConfigsetRevision
Response
Activates the specified revision of a configset, setting the state to ACTIVE. Make sure to validate the configset before activation. If a Configset with the same ID already exists, its state is set to INACTIVE.
ListConfigsetRevisions ListConfigsetRevisions
Request
ListConfigsetRevisions
Response
Lists configsets and their revisions. You can filter configsets by ID and state.
GetConfigset GetConfigset
Request
GetConfigset
Response
Gets the active revision of a configset.
GetConfigsetRevision GetConfigsetRevision
Request
GetConfigsetRevision
Response
Gets a configset revision content.
UpdateConfigsetDetails UpdateConfigsetDetails
Request
UpdateConfigsetDetails
Response
Updates configset details.
DeleteConfigset DeleteConfigset
Request
DeleteConfigset
Response
Deletes all revisions of the specified configset, including the active one.
DeleteConfigsetRevision DeleteConfigsetRevision
Request
DeleteConfigsetRevision
Response
Deletes a specific configset revision unless that revision is active. To delete an active revision, use the DeleteConfigset method.
CreateTemplate CreateTemplate
Request
CreateTemplate
Response
Creates a new template, validates, and activates it.
ListTemplates ListTemplates
Request
ListTemplates
Response
Lists configset templates. The context.gk_scope_id passed in the request must be authorized to list the templates.
GetTemplate GetTemplate
Request
GetTemplate
Response
Gets the content of the specified configset.
DeleteTemplate DeleteTemplate
Request
DeleteTemplate
Response
Deletes a configset template.
GenerateTemplate GenerateTemplate
Request
GenerateTemplate
Response
Generates a template from factory settings.

Methods with HTTP bindings

CreateConfigset

  POST /v1/configsets  

ValidateConfigsetRevision

  PUT /v1/configsets/revisions/{gk_configset_revision_id.value}:validate  

ActivateConfigsetRevision

  PUT /v1/configsets/revisions/{gk_configset_revision_id.value}:activate  

ListConfigsetRevisions

  GET /v1/configsets/revisions  

GetConfigset

  GET /v1/configsets/{configset_id}  

GetConfigsetRevision

  GET /v1/configsets/revisions/{gk_configset_revision_id.value}  

UpdateConfigsetDetails

  PATCH /v1/configsets/{configset_id}  

DeleteConfigset

  DELETE /v1/configsets/{configset_id}  

DeleteConfigsetRevision

  DELETE /v1/configsets/revisions/{gk_configset_revision_id.value}  

CreateTemplate

  POST /v1/templates  

ListTemplates

  GET /v1/templates  

GetTemplate

  GET /v1/templates/{template_id}  

DeleteTemplate

  DELETE /v1/templates/{template_id}  

GenerateTemplate

  POST /v1/factory-templates:generate  

config_message.proto

ActivateConfigsetRevisionRequest

Input message that defines parameters for ActivateConfigsetRevision.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ActivateConfigsetRevisionRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_configset_revision_id nuance.biosec.v1.UniqueId Mandatory. The unique ID of the configset revision.

ActivateConfigsetRevisionResponse

Output message that defines parameters returned by ActivateConfigsetRevision.

ActivateConfigsetRevisionResponse
Field Type Description
status nuance.rpc.Status General operation status.

ConfigsetDetailsForCreate

Contains fields that the system uses to create a configset. Included in CreateConfigsetRequest and CreateTemplateRequest.

ConfigsetDetailsForCreate
Field Type Description
description string The configset’s description (context).

ConfigsetDetailsForRead

Contains the readable fields of the configset. Included in GetConfigsetResponse and ListConfigsetRevisionsResponse.

ConfigsetDetailsForRead
Field Type Description
gk_configset_revision_id nuance.biosec.v1.UniqueId The unique ID of the configset revision.
configset_id string The configset’s ID.
type ConfigsetType The configset’s type.
creation_timestamp google.protobuf.Timestamp Date and time of creation.
modification_timestamp google.protobuf.Timestamp Date and time of last update.
description string The configset’s description (context).
created_by string The name of the user that created the configset.
updated_by string The name of the user that performed the most recent update to the configset.
state State The state of the configset.
config_class ConfigClass The configset’s class.

ConfigsetDetailsForUpdate

Contains the writable fields of the configset. Included in UpdateConfigsetDetailsRequest.

ConfigsetDetailsForUpdate
Field Type Description
description string The configset’s description (context).

ConfigsetFilter

The configset filter. Allows filtering by ID or state.

ConfigsetFilter
Field Type Description
configset_id string Filter by the Configset’s ID. No wildcards allowed. If not set, the search returns all configsets.
state repeated State Filter by state. If not set, the search returns configsets in any state.

ConfigsetGroupedByService

Contains a collection of the structured configset data, grouped by service.

ConfigsetGroupedByService
Field Type Description
service_config repeated ServiceConfig Lists service configuration parameters.

CreateConfigsetRequest

Input message that defines parameters for CreateConfigset.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
CreateConfigsetRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
configset_id string Mandatory. The configset’s ID.
type ConfigsetType Mandatory. The configset’s type.
details ConfigsetDetailsForCreate Optional. The configset’s additional details.
perform_validation bool Optional. Determines if the request validates the configset. By default, the method does not validate the configset.
One of configset_content:  
Mandatory. Content of the configset.
   raw_content bytes The configset’s data in an opaque byte array format.
   configset_object ConfigsetGroupedByService The data grouped by service.
   source_template_id string The (external) ID of a template that is used as the configset’s baseline.
   source_configset_id string The (external) ID of an existing configset that is used as the configset’s baseline.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ConfigsetDetailsForCreate fields that the method sets.

CreateConfigsetResponse

Output message that defines parameters returned by CreateConfigset.

CreateConfigsetResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_configset_revision_id nuance.biosec.v1.UniqueId The unique ID of the configset revision.

CreateTemplateRequest

Input message that defines parameters for CreateTemplate.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
CreateTemplateRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
template_id string Mandatory. The template’s ID.
type ConfigsetType Mandatory. The template’s type.
details ConfigsetDetailsForCreate Optional. The configset’s additional details.
One of template_content:  
Mandatory. The template’s content.
   raw_content bytes The template’s data in an opaque byte array format.
   configset_object ConfigsetGroupedByService The data grouped by service.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ConfigsetDetailsForCreate fields that the method sets.

CreateTemplateResponse

Output message that defines parameters returned by CreateTemplate.

CreateTemplateResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_template_id nuance.biosec.v1.UniqueId The unique ID of the template.

DeleteConfigsetRequest

Input message that defines parameters for DeleteConfigset.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
DeleteConfigsetRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
configset_id string Mandatory. The configset’s ID.

DeleteConfigsetResponse

Output message that defines parameters returned by DeleteConfigset.

DeleteConfigsetResponse
Field Type Description
status nuance.rpc.Status General operation status.

DeleteConfigsetRevisionRequest

Input message that defines parameters for DeleteConfigsetRevision.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
DeleteConfigsetRevisionRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_configset_revision_id nuance.biosec.v1.UniqueId Mandatory. The unique ID of the configset revision.

DeleteConfigsetRevisionResponse

Output message that defines parameters returned by DeleteConfigsetRevision.

DeleteConfigsetRevisionResponse
Field Type Description
status nuance.rpc.Status General operation status.

DeleteTemplateRequest

Input message that defines parameters for DeleteTemplate.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
DeleteTemplateRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
template_id string Mandatory. The template’s ID.

DeleteTemplateResponse

Output message that defines parameters returned by DeleteTemplate.

DeleteTemplateResponse
Field Type Description
status nuance.rpc.Status General operation status.

GenerateTemplateRequest

Input message that defines parameters for GenerateTemplate.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GenerateTemplateRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
template_id string Mandatory. The template’s ID. List of available template IDs for CONFIGSET_TYPE_OPERATIONAL: 1. ContactCenterDefault 2. ContactCenterEnroll 3. CallCenterRealtimeFraudDetection 4. IVRTextDependent 5. PostCallFraudDetection
type ConfigsetType Mandatory. The template’s type.

GenerateTemplateResponse

Output message that defines parameters returned by GenerateTemplate.

GenerateTemplateResponse
Field Type Description
status nuance.rpc.Status General operation status.
gk_template_id nuance.biosec.v1.UniqueId The unique ID of the template.

GetConfigsetRequest

Input message that defines parameters for GetConfigset.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GetConfigsetRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
configset_id string Mandatory. The configset’s ID.
expected_format ConfigsetFormat Mandatory. The expected data format.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ConfigsetDetailsForRead fields that the method reads.

GetConfigsetResponse

Output message that defines parameters returned by GetConfigset.

GetConfigsetResponse
Field Type Description
status nuance.rpc.Status General operation status.
details ConfigsetDetailsForRead The configset’s details.
One of configset_content:  
The configset’s content.
   raw_content bytes The configset’s data in an opaque byte array format.
   configset_object ConfigsetGroupedByService The data grouped by service.

GetConfigsetRevisionRequest

Input message that defines parameters for GetConfigsetRevision.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GetConfigsetRevisionRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_configset_revision_id nuance.biosec.v1.UniqueId Mandatory. The unique ID of the configset revision.
expected_format ConfigsetFormat Mandatory. The expected data format.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ConfigsetDetailsForRead fields that the method reads.

GetConfigsetRevisionResponse

Output message that defines parameters returned by GetConfigsetRevision.

GetConfigsetRevisionResponse
Field Type Description
status nuance.rpc.Status General operation status.
details ConfigsetDetailsForRead The configset’s details.
One of configset_content:  
The configset’s content.
   raw_content bytes The configset’s data in an opaque byte array format.
   configset_object ConfigsetGroupedByService The data grouped by service.

GetTemplateRequest

Input message that defines parameters for GetTemplate.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
GetTemplateRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
template_id string Mandatory. The template’s ID.
expected_format ConfigsetFormat Mandatory. The expected data format.

GetTemplateResponse

Output message that defines parameters returned by GetTemplate.

GetTemplateResponse
Field Type Description
status nuance.rpc.Status General operation status.
One of template_content:  
The template’s content.
   raw_content bytes The template’s data in an opaque byte array format.
   configset_object ConfigsetGroupedByService The data grouped by service.

ListConfigsetRevisionsRequest

Input message that defines parameters for ListConfigsetRevisions.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ListConfigsetRevisionsRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
filter ConfigsetFilter Optional. A filter that limits the list to a specific configset ID or state.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ConfigsetDetailsForRead fields that the method reads.

ListConfigsetRevisionsResponse

Output message that defines parameters returned by ListConfigsetRevisions. The list is ordered by the creation timestamp in descending order.

ListConfigsetRevisionsResponse
Field Type Description
status nuance.rpc.Status General operation status.
details repeated ConfigsetDetailsForRead List of configsets and their attributes.

ListTemplatesRequest

Input message that defines parameters for ListTemplates.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ListTemplatesRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
filter ConfigsetFilter Optional. A filter that limits the list to a specific template ID or state.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ConfigsetDetailsForRead fields that the method reads.

ListTemplatesResponse

Output message that defines parameters returned by ListTemplates.

ListTemplatesResponse
Field Type Description
status nuance.rpc.Status General operation status.
details repeated ConfigsetDetailsForRead List of templates and their attributes.

ServiceConfig

Contains the structured configset data of a single service.

ServiceConfig
Field Type Description
service_name string The name of the service.
data bytes The service configuration data.
schema bytes Schema definition of the configuration data. Trivial while creating a configset and getting its revision.

UpdateConfigsetDetailsRequest

Input message that defines parameters for UpdateConfigsetDetails.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
UpdateConfigsetDetailsRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
configset_id string Mandatory. The configset’s ID.
details ConfigsetDetailsForUpdate Mandatory. Configset details to be updated.
field_mask google.protobuf.FieldMask Mandatory. A field mask used to specify the ConfigsetDetailsForUpdate fields that the method sets.

UpdateConfigsetDetailsResponse

Output message that defines parameters returned by UpdateConfigsetDetails.

UpdateConfigsetDetailsResponse
Field Type Description
status nuance.rpc.Status General operation status.

ValidateConfigsetRevisionRequest

Input message that defines parameters for ValidateConfigsetRevision.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Mandatory
  • configset_id: Not used
ValidateConfigsetRevisionRequest
Field Type Description
context nuance.biosec.v1.Context Mandatory. General request context.
gk_configset_revision_id nuance.biosec.v1.UniqueId Mandatory. The unique ID of the configset revision.

ValidateConfigsetRevisionResponse

Output message that defines parameters returned by ValidateConfigsetRevision. In case one or more parameters are invalid, the list of validation errors are returned in the the FieldViolation field in the Status.

ValidateConfigsetRevisionResponse
Field Type Description
status nuance.rpc.Status General operation status. Contains the list of validation errors.

config_enum.proto

ConfigClass

The configset class. Indicates if this is a standard configset or a template. Templates expedite the configset creation process for common scenarios ensuring all necessary parameters are optimally set.

Name Number Description
CONFIG_CLASS_UNSPECIFIED 0 The config class is not specified. Do not use this value.
CONFIG_CLASS_CONFIGSET 1 Standard configset.
CONFIG_CLASS_TEMPLATE 2 Indicates that the configuration is a template.

ConfigsetFormat

The format of the configset content.

Name Number Description
CONFIGSET_FORMAT_UNSPECIFIED 0 The configset format is not specified. Do not use this value.
CONFIGSET_FORMAT_ALL_BYTES 1 The configset data format is an opaque array of bytes.
CONFIGSET_FORMAT_BY_SERVICE 2 The configset data format is an array of binary serialized parameters grouped by their owner service.

ConfigsetType

The configset type.

Name Number Description
CONFIGSET_TYPE_UNSPECIFIED 0 The configset type is not specified. Do not use this value.
CONFIGSET_TYPE_SYSTEM 1 Configset contains all system-level parameters.
CONFIGSET_TYPE_SCOPE 2 Configset contains all scope-level parameters.
CONFIGSET_TYPE_OPERATIONAL 3 Configset contains all operational parameters.

State

The configset state. Only active configsets affect the system behavior. Other states allow managing configsets before they are ready to be activated or after they are no longer in use.

Name Number Description
STATE_UNSPECIFIED 0 Configset state is not set.
STATE_SAVED 1 Configset is created.
STATE_VALIDATED 2 Configset is validated successfully.
STATE_ACTIVE 3 Configset is activated. Only configsets in this state affect system behavior.
STATE_INACTIVE 4 Configset is explicitly deactivated or another revision of the configset is activated.
STATE_INVALID 5 Configset is invalid due to incorrect parameters.